using LAview, Core, GObject.Plugins;

extern const string GETTEXT_PACKAGE;

/**
 * Plugin of type A1.
 */
public class PluginProtocolExample : PluginProtocol {

	/**
	 * Constructs a new ``PluginProtocolExample``.
	 */
	construct {
		stdout.puts ("PluginProtocolExample init () called\n");
	}

	/**
	 * Destroys the ``PluginProtocolExample``.
	 */
	~PluginProtocolExample () {
		stdout.puts ("PluginProtocolExample deinit () called\n");
	}

	/**
	 * Any abstract method realization for PluginProtocol.
	 */
	public override string get_readable_name () {
		stdout.puts ("PluginProtocolExample.get_readable_name () called\n");
		stdout.puts ("Call IHostCore.any_host_method () from PluginProtocolExample:\n  ");
		(host as IHostCore).any_host_method ();
		return _("Protocol Example");
	}
}

[ModuleInit]
Type plugin_init (GLib.TypeModule type_module) {
	return typeof (PluginProtocolExample);
}
